// Copyright (c) 2006 David Drysdale.  See license.txt for license info
class Format {
  static public String round(double d) {
    double PRECISION=1000.0;
    d = (double)((int)(d*PRECISION)) / PRECISION;
    return "" + d;
  }
  static public String round(SharedDouble d) {
    return round(d.doubleValue());
  }
  static public char[] expect(char[] s, int offset, String vs) {
    char[] v = vs.toCharArray();
    int ii=offset;
    // skip whitespace
    while (isWhitespace(s[ii])) ii++;
    for (int jj=0; jj<v.length; jj++) {
      if (s[ii+jj] != v[jj]) throw new NumberFormatException("failed to find expected string '"+vs+"' in "+new String(s));
    }
    char[] left = new char[s.length - v.length - ii];
    System.arraycopy(s, ii+v.length, left, 0, s.length - v.length - ii);
    return left;
  }
  static public char[] expect(char[] s, String vs) {
    return expect(s, 0, vs);
  }
  static public boolean isHexDigit(char c) {
    if (c >= '0' && c <= '9') return true;
    if (c >= 'a' && c <= 'f') return true;
    if (c >= 'A' && c <= 'F') return true;
    return false;
  }
  static public boolean isWhitespace(char c) {
    if (c == ' ') return true;
    if (c == '\n') return true;
    if (c == '\r') return true;
    if (c == '\t') return true;
    return false;
  }
};