// Copyright (c) 2006 David Drysdale.  See license.txt for license info
class Line3DSequence extends Sequence {
  public Line3D[][] lines_;
  public int numLines_;
  public Line3DSequence(int numFrames, int numLines) {
    super(numFrames);
    lines_ = new Line3D[numFrames][];
    for (int ii=0; ii<numFrames; ii++) {
      lines_[ii] = new Line3D[numLines];
      for (int jj=0; jj<numLines; jj++) {
        lines_[ii][jj] = new Line3D();
      }
    }
  }
  public Point3D findCentre(int which) {
    Point3D sum = new Point3D();
    sum.x = 0.0; sum.y = 0.0; sum.z = 0.0;
    for (int jj = 0; jj < lines_[which].length; jj++) {
      sum.x += lines_[which][jj].a.x;
      sum.x += lines_[which][jj].b.x;
      sum.y += lines_[which][jj].a.y;
      sum.y += lines_[which][jj].b.y;
      sum.z += lines_[which][jj].a.z;
      sum.z += lines_[which][jj].b.z;
    }
    sum.x /= (double)(2*lines_[which].length);
    sum.y /= (double)(2*lines_[which].length);
    sum.z /= (double)(2*lines_[which].length);
    return sum;
  }
  public Point3D findCentre() {
    Point3D sum = new Point3D();
    sum.x = 0.0; sum.y = 0.0; sum.z = 0.0;
    for (int ii = 0; ii < length(); ii++) {
      Point3D frameCentre = findCentre(ii);
      sum.x += frameCentre.x;
      sum.y += frameCentre.y;
      sum.z += frameCentre.z;
    }
    sum.x /= (double)(length());
    sum.y /= (double)(length());
    sum.z /= (double)(length());
    return sum;
  }
  public Line3D[] frame(int which) {
    return lines_[which];
  }
};
