// Copyright (c) 2006 David Drysdale.  See license.txt for license info
import java.awt.*;

class LoadDialog extends Dialog {
    Button okButton;
    Button cancelButton;
    Panel labelPanel;
    TextArea textStuff;
    Panel buttonPanel;
    boolean answer = false;
    LoadDialog(Frame frame, boolean modal) {
        super(frame, modal);

        labelPanel = new Panel();
        labelPanel.setLayout(new BorderLayout());
        labelPanel.add("North", 
                       new Label("I'm a Java applet, so I'm not allowed to read from your disk. However, you are, so you should"));
        labelPanel.add("Center", 
                       new Label("load up a saved figure file in a text editor, then copy and paste the description below."));

        add("North", labelPanel);
        textStuff = new TextArea();
        Font fixedFont = new Font("Courier", Font.PLAIN, 10);
        if (fixedFont != null) textStuff.setFont(fixedFont);
        add("Center", textStuff);
        buttonPanel = new Panel();
        buttonPanel.setLayout(new BorderLayout());
        okButton = new Button("OK");
        cancelButton = new Button("Cancel");
        buttonPanel.add("West", okButton);
        buttonPanel.add("East", cancelButton);
        add("South", buttonPanel);
        pack();
    }
    public boolean action(Event e, Object what) {
        if (e.target == okButton) {
            answer = true;
            setVisible(false);
            return true;
        } else if (e.target == cancelButton) {
            answer = false;
            setVisible(false);
            return true;
        }
        return false;
    }
    public boolean getAnswer() {return answer;}
    public String getText() {return textStuff.getText();}
}
