// Copyright (c) 2006 David Drysdale.  See license.txt for license info
class PointHighlightControl implements Control {
  Camera camera_;
  boolean fixed_;
  Point3D pt_;
  SharedDouble px_;
  SharedDouble py_;
  SharedDouble pz_;
  Control nextControl_;
  static boolean verbose_ = false;

  public PointHighlightControl(Point3D pt, Camera camera) {
    pt_ = pt;
    fixed_ = true;
    camera_ = camera;
  }
  public PointHighlightControl(SharedDouble dx, SharedDouble dy, SharedDouble dz, Camera camera) {
    px_ = dx;
    py_ = dy;
    pz_ = dz;
    fixed_ = false;
    camera_ = camera;
  }
  public void display(Drawable2D c, java.awt.Graphics g) {
    Point3D pt;
    if (fixed_) {
      pt = pt_;
    } else {
      pt = new Point3D(px_.doubleValue(), py_.doubleValue(), pz_.doubleValue());
    }
    if (verbose_) pt.dump("highlight point at");
    
    Point2D pos = camera_.transform(pt);
    if (verbose_) pos.dump("which is 2d point");
    c.point(pos.x,pos.y, java.awt.Color.white);
    
    if (nextControl_ != null) {
      nextControl_.display(c,g);
    }
  }
};