// Copyright (c) 2006 David Drysdale.  See license.txt for license info
class SharedDouble {
  private double value_;
  public SharedDouble() {value_ = 0;}
  public SharedDouble(double v) {value_ = v;};
  public double doubleValue() {return value_;}
  public synchronized void setDoubleValue(double v) {value_ = v;}
  public void addDoubleValue(double v) {value_ += v;}
  public String toString() {return ""+value_;}
  public static boolean isNumChar(char c) {
    if (c=='.' || c =='-' || (c>='0' && c<='9')) return true;
    return false;
  }
  public char[] fromString(char[] s) {
    int ii=0;
    // Move past start whitespace
    while (s[ii] == ' ') ii++;
    int jj=ii;
    // Find the end of the string
    while  ((jj<s.length) && (isNumChar(s[jj]))) jj++;
    String ds = new String(s, ii, jj-ii);
    Double dd = new Double(ds);
    value_ = dd.doubleValue();

    // Return what's left of the string
    char[] left = new char[s.length - jj];
    System.arraycopy(s, jj, left, 0, s.length -jj);
    return left;
  }
  public String fromString(String s) {
    char[] chars = s.toCharArray();
    return new String(fromString(chars));
  }
};