// Copyright (c) 2006 David Drysdale.  See license.txt for license info
class SimpleMove extends Move {
  FiguresSequence figSeq_;

  SimpleMove(String name, FiguresSequence figSeq) {
    super(name);
    Move.register(name_, this);
    figSeq_ = figSeq;
  }
  public FiguresSequence getFigSeq() {return figSeq_;}

  public String toString() {
    String result = super.toString() + " type=simple ";
    result += figSeq_;
    return result;
  }
  public char[] fromString(char[] s) {
    s = super.fromString(s);
    s = Format.expect(s, "type=simple");
    s = figSeq_.fromString(s);
    return s;
  }
  public String fromString(String s) {
    char[] chars = s.toCharArray();
    return new String(fromString(chars));
  }
};